// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function util_get_current_webiste_domain(url=''){
    let current_url = url;
    if(current_url){
        current_url = current_url.replace('https://','');
        let current_url_arr = current_url.split('/');
        return current_url_arr[0];
    }
    return 'us.shein.com';
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.rawData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function pause_s_time(){
    chrome.storage.local.get(null, function(items) {
        //
        chrome.storage.local.set({pause_s_time: Date.now()});
    });
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

function pause_list_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_list';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_list: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_list: 0}, callback);
            }else{
                chrome.storage.local.set({pause_list: 1}, callback);
            }
        }
    });
}

function field_name_set(field_name = '', callback){
    chrome.storage.local.set({field_name: field_name}, callback);
}
// Function to convert an image to a Blob
async function imageToBlob(imageUrl) {
  try {
    // Fetch the image as an array buffer
    const response = await fetch(imageUrl);
    const arrayBuffer = await response.arrayBuffer();

    // Create a Blob from the array buffer
    const blob = new Blob([arrayBuffer], { type: response.headers.get("content-type") });

    return blob;
  } catch (error) {
    console.error("Error converting image to Blob:", error);
    return null;
  }
}

// Usage example:
/*const imageUrl = "https://img.kwcdn.com/product/Fancyalgo/VirtualModelMatting/8af63f79afdd388711b1c34289c15cda.jpg?imageView2/2/w/800/q/70/format/webp";
imageToBlob(imageUrl)
  .then(blob => {
    if (blob) {
      // Do something with the Blob, such as uploading it or displaying it
        console.log('aaaa');
        console.log(blob);
    } else {
        console.log("Failed to convert image to Blob.");
    }
  });*/

function urlToBase64(url, callback) {
  const xhr = new XMLHttpRequest();
  xhr.onload = function() {
    const reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result);
    };
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}

// 使用示例
/*const imageUrl = 'https://example.com/image.jpg'; // 替换为你自己的图片URL
urlToBase64(imageUrl, function(base64String) {
  console.log(base64String); // 这里是Base64编码的图片字符串
});*/
//
function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={}, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                //'_shangjia_name': _shangjia_info['_shangjia_name'],
                //'_shangjia_catalog_1': '',
                //'_shangjia_catalog_2': '',
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['_shangjia_a_link'],
                '_is_request':0,

                //'_shangjia_img': _shangjia_info['_shangjia_img'],
                //'_shangjia_images': '',
                //'_shangjia_img_blob': '',
                //'_shangjia_price': _shangjia_info['_shangjia_price'],
               // '_shangjia_old_price': _shangjia_info['_shangjia_old_price'],
                //'_shangjia_review_score': _shangjia_info['_shangjia_review_score'],
                //'_shangjia_reivew_num': _shangjia_info['_shangjia_reivew_num'],
                //'_shangjia_sold': _shangjia_info['_shangjia_sold'],
                //'_shangjia_desc':'',

                '_shangjia_store_name': '',
                '_shangjia_store_url': '',
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_score': '',
                //
                '_shangjia_goodsId':'', //sku
                '_shangjia_variants_skus': [], //数组
                '_shangjia_goodsName': '',
                '_shangjia_goodsProperty':'',//description,deschtml
                '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
                '_shangjia_hdThumbUrl': '',//主图
                '_shangjia_gallery':[], //图片列表
                '_shangjia_productDetailFlatList':[],//details imgs
                '_shangjia_category':'',//brumb
                '_shangjia_VideoUrl':'', //video
                //

            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function util_timeConsumingFunction(seconds) {
  // 将秒数转换为毫秒
  const milliseconds = seconds * 1000;

  // 模拟耗时操作，例如循环计算
  const startTime = new Date().getTime();
  while (new Date().getTime() - startTime < milliseconds) {
    // 一些计算
  }
}

function shangjia_get_subskus(_dom,_shangjia_goodsId='',
                              specs_key1_name='',
                              _specs_key1_value = '',
                              specs_key2_name='',
                              _shangjia_gallery = [],
                              _main_image=''){
    //
    let _shangjia_variants_skus_cucao = [];
    _dom.find('.product-intro__size-choose .product-intro__size-radio-spopover').each(function (){
        //
        let specs_key2_value = $(this).find('.product-intro__size-radio').attr('aria-label');
        //
        let _subsku = _shangjia_goodsId+_specs_key1_value+'-'+specs_key2_value;
        //
        //
        let _original_price = '';
        _original_price = _dom.find('.ProductIntroHeadPrice__head-mainprice .del-price').text();
        if(_original_price == '' || typeof _original_price == 'undefined'){
            _original_price = _dom.find('.ProductIntroHeadPrice__head-mainprice .original span').text();
        }
        //
        let _discount_price = _dom.find('.ProductIntroHeadPrice__head-mainprice .original span').text();
        if(_discount_price=='' || typeof _discount_price == 'undefined'){
            _discount_price = _original_price;
        }
        //
        if(_discount_price =='' && _original_price ==''){
            _original_price = _dom.find('.price-estimated-percent__retail span.price-num').text();
            _discount_price = _dom.find('.price-estimated-percent__price').text();
        }
        if(_original_price){
            _original_price = _original_price.replace('¥','').replace('$','');
        }
        if(_discount_price){
            _discount_price = _discount_price.replace('¥','').replace('$','');
        }
        //
        _shangjia_variants_skus_cucao.push({
            'subsku': _subsku, //自定义变体带属性SKU
            'normalPriceStr': _discount_price, //特价
            'normalLinePriceStr': _original_price, //原价
            'img':_main_image,
            'gallery_imgs':_shangjia_gallery,
            'video_url':'',
            'specs_key1_name':_specs_key1_value!=''?specs_key1_name:'',
            'specs_key1_value':_specs_key1_value,
            'specs_key2_name':specs_key2_name,
            'specs_key2_value':specs_key2_value,
            'specs_key3_name':'',
            'specs_key3_value':'',
            'specs_key4_name':'',
            'specs_key4_value':'',
            'stockQuantity': '',
            'skuId': '' //原变体sku
        });
    });
    //console.log('_shangjia_variants_skus_cucao');
    //console.log(_shangjia_variants_skus_cucao);
    return _shangjia_variants_skus_cucao;
    //
}

function util_get_json(url= ''){
    console.log('url:'+url);
    let r_data = '';
    $.ajax({
            url:url,
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:false,
            dataType: 'json',
            crossDomain: true,
            cache: false,
            success: function(data) {
                console.log('util_get_json:'+url);
                console.log(data);
                r_data =  data;
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('util_get_json遇到反爬');
                console.log( jqXHR, textStatus, errorThrown );
            }
        });
    return r_data;
}

function shangjia_get_subskus_ajax(current_domain,_shangjia_goodsId='',
                              specs_key1_name='',
                              specs_key2_name='',
                              relation_color_data={},_size_arr=[]){
    //
    let _shangjia_variants_skus_cucao = [];
    let subsku_url = 'https://'+current_domain+'/api/productInfo/quickView/get?_ver=1.1.8&_lang=en&goods_id='+relation_color_data['goods_id']+'&template=1&mallCode=1&isFromDetail=1&closeEstimatedPrice=0';
    let subsku_json_data = util_get_json(subsku_url);
    if(subsku_json_data){
        let _goods_detail = subsku_json_data['info']['goods']['detail'];
        let _specs_key1_value = subsku_json_data['info']['goods']['detail']['mainSaleAttribute'][0]['attr_value'];
        let _original_price = subsku_json_data['info']['goods']['detail']['retailPrice']['amount'];
        let _discount_price = subsku_json_data['info']['goods']['detail']['salePrice']['amount'];
        let _stockQuantity = subsku_json_data['info']['goods']['detail']['stock'];
        let _goods_imgs =  subsku_json_data['info']['goods']['goods_imgs'];
        let _detail_image = _goods_imgs['detail_image'];
        let _color_image = '';
        if(_goods_detail.hasOwnProperty('color_image')){
            _color_image = _goods_detail['color_image'];
            if(_color_image){
                _color_image = _color_image.replace('//','');
            }
        }

        let _shangjia_gallery = [];
        for(let _d=0;_d<_detail_image.length;_d++){
             let _origin_image = _detail_image[_d]['origin_image'];
             if(_origin_image.indexOf('http') == -1){
                 _origin_image = _origin_image.replace('//','http://');
             }
            _shangjia_gallery.push(_origin_image);
        }
        let _img = _goods_imgs['main_image']['origin_image'];
        if(_img.indexOf('http') == -1){
            _img = _img.replace('//','http://');
        }
        //
        let _video_url = _goods_imgs['video_url'];
        //
        if(_size_arr.length>0){
           for(let _s=0;_s<_size_arr.length;_s++){
                //
                let specs_key2_value = _size_arr[_s];
                //
                let _subsku = _shangjia_goodsId+_specs_key1_value+'-'+specs_key2_value;
                if(_specs_key1_value == "Multicolor"){
                    _subsku = _goods_detail['goods_sn']+_specs_key1_value+'-'+specs_key2_value;
                }
                _shangjia_variants_skus_cucao.push({
                        'subsku': _subsku, //自定义变体带属性SKU
                        'normalPriceStr': _discount_price, //特价
                        'normalLinePriceStr': _original_price, //原价
                        'color_image':_color_image,
                        'img':_img,
                        'gallery_imgs':_shangjia_gallery,
                        'video_url':_video_url,
                        'specs_key1_name':specs_key1_name,
                        'specs_key1_value':_specs_key1_value,
                        'specs_key2_name':specs_key2_name,
                        'specs_key2_value':specs_key2_value,
                        'specs_key3_name':'',
                        'specs_key3_value':'',
                        'specs_key4_name':'',
                        'specs_key4_value':'',
                        'stockQuantity': _stockQuantity,
                        'skuId': '' //原变体sku
                });
            }
        }else{
            //
            let _subsku = _shangjia_goodsId+_specs_key1_value;

            _shangjia_variants_skus_cucao.push({
                'subsku': _subsku, //自定义变体带属性SKU
                'normalPriceStr': _discount_price, //特价
                'normalLinePriceStr': _original_price, //原价
                'color_image':_color_image,
                'img':_img,
                'gallery_imgs':_shangjia_gallery,
                'video_url':_video_url,
                'specs_key1_name':specs_key1_name,
                'specs_key1_value':_specs_key1_value,
                'specs_key2_name':specs_key2_name,
                'specs_key2_value':'',
                'specs_key3_name':'',
                'specs_key3_value':'',
                'specs_key4_name':'',
                'specs_key4_value':'',
                'stockQuantity': _stockQuantity,
                'skuId': '' //原变体sku
            });
            //
        }
    }
    console.log('_shangjia_variants_skus_cucao');
    console.log(_shangjia_variants_skus_cucao);
    return _shangjia_variants_skus_cucao;
    //
}


function util_getscript_goodsDetailV3SsrData_content_old(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('goodsDetailV3SsrData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_getscript_goodsDetailV3SsrData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.gbRawData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function request_shangjia_about_contact_and_basic_info_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //
        //need_item['_shangjia_about_contact_and_basic_info_link'] = 'https://www.temu.com/goods.html?_bg_fs=1&goods_id=601099513966458';
        if(need_item['_shangjia_about_contact_and_basic_info_link'] && need_item['_shangjia_about_contact_and_basic_info_link'].indexOf('-p-') ==-1){
            need_item['_e_time'] = Date.now();
            need_item['_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
            });
            return;
        }
        console.log('request_shangjia_about_contact_and_basic_info_ajax aaa');
        console.log(need_item['_shangjia_about_contact_and_basic_info_link']);
        //
        $.ajax({
            url:need_item['_shangjia_about_contact_and_basic_info_link'],
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                console.log('data');
                //console.log(data);
               let _dom = $(data);
               //
               let _mainContent = _dom.find('.mainContent').text();
               let _baseContent = _dom.find('.baseContent').text();
               let _checkContent = _mainContent;
               if(_baseContent){
                   _checkContent += _baseContent;
               }
               if(false && util_checkFanpa(_checkContent)){
                   console.log('util_checkFanpa a1');
                   //
                    need_item['_is_request'] = 0;
                    need_item['_error'] = '遇到Shein反爬,请开启或者更换代理或者暂停采集，稍后再采集!';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                            //

                            //
                    });
                    pause_s_time();
                    sendPopTips("遇到Shein反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
               }else{
                   //console.log('util_checkFanpa a2');
                   let current_domain = util_get_current_webiste_domain(need_item['_shangjia_about_contact_and_basic_info_link']);
                   //
                   let _shangjia_goodsName = _dom.find('.product-intro__head-name').text();
                   if(_shangjia_goodsName){
                       //
                        let _goodsDetailV3SsrData = util_getscript_goodsDetailV3SsrData_content(data);
                        let _goodsDetailV3SsrData_json = {};
                        if(_goodsDetailV3SsrData) {
                            _goodsDetailV3SsrData_arr = _goodsDetailV3SsrData.split('document.dispatchEvent');
                            if (_goodsDetailV3SsrData_arr.length == 2) {
                                _goodsDetailV3SsrData = _goodsDetailV3SsrData_arr[0];
                                _goodsDetailV3SsrData = _goodsDetailV3SsrData.replace('window.gbRawData =', '');
                                _goodsDetailV3SsrData = _goodsDetailV3SsrData.trim();
                                _goodsDetailV3SsrData_json = JSON.parse(_goodsDetailV3SsrData);
                                console.log('_goodsDetailV3SsrData_json');
                                console.log(_goodsDetailV3SsrData_json);
                                //
                                let shangjia_info = {};
                                let _shangjia_goodsId = _dom.find('.product-intro__head-sku').text();
                                _shangjia_goodsId =_shangjia_goodsId.replace('SKU:','');
                                _shangjia_goodsId = _shangjia_goodsId.trim();
                                need_item['_shangjia_goodsId'] = _shangjia_goodsId;
                                //
                                need_item['_product_url'] = need_item['_shangjia_about_contact_and_basic_info_link'];
                                //
                                _shangjia_goodsName = _shangjia_goodsName.trim();
                                need_item['_shangjia_goodsName'] = _shangjia_goodsName;
                                //
                                let _original_price = '';
                                _original_price = _dom.find('.ProductIntroHeadPrice__head-mainprice .del-price').text();
                                if(_original_price == '' || typeof _original_price == 'undefined'){
                                    _original_price = _dom.find('.ProductIntroHeadPrice__head-mainprice .original span').text();
                                }
                                //
                                let _discount_price = _dom.find('.ProductIntroHeadPrice__head-mainprice .original span').text();
                                if(_discount_price=='' || typeof _discount_price == 'undefined'){
                                    _discount_price = _original_price;
                                }
                                //
                                if(_discount_price =='' && _original_price ==''){
                                    _original_price = _dom.find('.price-estimated-percent__retail span.price-num').text();
                                    _discount_price = _dom.find('.price-estimated-percent__price').text();
                                }
                                //
                                let _shangjia_minOnSalePriceStr = _discount_price;
                                if(_shangjia_minOnSalePriceStr){
                                    _shangjia_minOnSalePriceStr = _shangjia_minOnSalePriceStr.replace('¥','').replace('$','');
                                    _shangjia_minOnSalePriceStr = _shangjia_minOnSalePriceStr.trim();
                                }
                                if(_original_price){
                                     _original_price = _original_price.replace('¥','').replace('$','');
                                }
                                need_item['_shangjia_minOnSalePriceStr'] = _shangjia_minOnSalePriceStr;
                                need_item['_shangjia_minOriginPriceStr'] = _original_price;
                                //
                                let productDetails = _goodsDetailV3SsrData_json['productIntroData']['detail']['productDetails'];
                                let _shangjia_desc = '';
                                if(productDetails){
                                    for(let _pd_key in productDetails){
                                        _shangjia_desc += '<div class="product-intro__description-table-item" tabindex="0" role="text"><div class="key">'+productDetails[_pd_key]['attr_name']+': </div><div class="val">'+productDetails[_pd_key]['attr_value']+'<span dir="ltr"></span></div></div>';
                                    }
                                }
                                //
                                need_item['_shangjia_desc'] = "<div class='product-intro__description'><div class='product-intro__description-table'>"+_shangjia_desc+"</div></div>";
                                //
                                let  _product_intro__sizeguide = _dom.find('.product-intro__sizeguide .product-intro__sizeguide-panel').html();
                                if(typeof _product_intro__sizeguide == 'undefined'){
                                    _product_intro__sizeguide = '';
                                }else{
                                    _product_intro__sizeguide = "<div class='product-intro__sizeguide'>"+_product_intro__sizeguide+"</div>";
                                }
                                //need_item['_product_intro__sizeguide'] = _product_intro__sizeguide;
                                need_item['_product_intro__sizeguide'] = '';
                                //
                                let _shangjia_goodsProperty = "";
                                need_item['_shangjia_goodsProperty'] = _shangjia_goodsProperty;
                                //
                                //
                                let _shangjia_gallery = [];
                                //
                                let _goods_imgs =  _goodsDetailV3SsrData_json['productIntroData']['goods_imgs'];
                                let _detail_image = _goods_imgs['detail_image'];

                                for(let _d=0;_d<_detail_image.length;_d++){
                                     let _origin_image = _detail_image[_d]['origin_image'];
                                     if(_origin_image.indexOf('http') == -1){
                                         _origin_image = _origin_image.replace('//','http://');
                                     }
                                    _shangjia_gallery.push(_origin_image);
                                }
                                let _main_image = _goods_imgs['main_image']['origin_image'];
                                if(_main_image.indexOf('http') == -1){
                                    _main_image = _main_image.replace('//','http://');
                                }
                                /*_dom.find('.product-intro__gallery .product-intro__thumbs-item').each(function (){
                                    let _img = $(this).find('img').attr('data-src');
                                    if(_img && _img.indexOf('_thumbnail') !=-1){
                                        let _img_arr = _img.split('_thumbnail');
                                        let _img_wei = _img_arr[1];
                                        let _img_wei_arr = _img_wei.split('.');
                                        _img = _img_arr[0]+'.'+_img_wei_arr[1];
                                        if(_img.indexOf('http') == -1){
                                             _img = _img.replace('//','http://');
                                         }
                                    }
                                    _shangjia_gallery.push(_img);
                                });
                                let _shangjia_hdThumbUrl = _shangjia_gallery[0];
                                need_item['_shangjia_hdThumbUrl'] = _shangjia_hdThumbUrl;*/
                                need_item['_shangjia_hdThumbUrl'] = '';
                                //
                                need_item['_shangjia_productDetailFlatList'] = [];
                                let _shangjia_VideoUrl = _goodsDetailV3SsrData_json['productIntroData']['goods_imgs']['video_url'];
                                need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                                //子sku
                                let specs_key1_name = '';
                                let specs_key2_name = '';
                                specs_key1_name = _dom.find('.product-intro__select-box .product-intro__color .title').text();
                                if(typeof specs_key1_name != "undefined"){
                                    specs_key1_name = specs_key1_name.replace(':','');
                                }else{
                                    specs_key1_name = '';
                                }
                                //
                                specs_key2_name = _dom.find('.product-intro__select-box .product-intro__size .product-intro__size-title').attr('aria-label');
                                if(typeof specs_key2_name == 'undefined'){
                                    specs_key2_name = '';
                                }
                                //如果color存在且大于2个，则不采集
                                let specs_key1_name_values_num = 0;
                                _dom.find('.product-intro__color_choose .product-intro__color-radio,.goods-color__radio-container span.sui-popover__trigger').each(function (){
                                    specs_key1_name_values_num +=1;
                                });
                                _dom.find('.product-intro__color_choose .product-intro__color-block').each(function (){
                                    specs_key1_name_values_num +=1;
                                });
                                let _shangjia_variants_skus = [];
                                if(specs_key1_name_values_num >= 1){
                                    _shangjia_gallery = [];
                                    let _size_arr = [];
                                    _dom.find('.product-intro__size-choose .product-intro__size-radio-spopover').each(function (){
                                        let specs_key2_value = $(this).find('.product-intro__size-radio').attr('aria-label');
                                        _size_arr.push(specs_key2_value);
                                    });
                                    let relation_color_arr = _goodsDetailV3SsrData_json['productIntroData']['relation_color'];
                                    //把自己加上去
                                    relation_color_arr.unshift({
                                        'goods_id': _goodsDetailV3SsrData_json['productIntroData']['detail']['goods_id']
                                    })
                                    console.log('relation_color_arr');
                                    console.log(relation_color_arr);
                                    //
                                    for(let _r=0;_r<relation_color_arr.length;_r++){
                                        let _shangjia_variants_skus_cucao = shangjia_get_subskus_ajax(current_domain,
                                            need_item['_shangjia_goodsId'],
                                            specs_key1_name,
                                            specs_key2_name,
                                            relation_color_arr[_r],
                                            _size_arr);
                                        if(_shangjia_variants_skus_cucao){
                                            for(let _c=0;_c<_shangjia_variants_skus_cucao.length;_c++){
                                                //
                                                if(_c==0){
                                                    //同一个颜色有多个尺寸，只取第一个即可
                                                    let _gallery_imgs = _shangjia_variants_skus_cucao[_c]['gallery_imgs'];
                                                    for(let _g=0;_g<_gallery_imgs.length;_g++){
                                                        _shangjia_gallery.push(_gallery_imgs[_g]);
                                                    }
                                                }
                                                //
                                                _shangjia_variants_skus.push(_shangjia_variants_skus_cucao[_c]);
                                            }
                                        }else{
                                            //可能
                                            console.log('util_get_json可能遇到反爬');
                                            need_item['_is_request'] = 0;
                                            need_item['_error'] = '';
                                            pause_s_time();
                                            sendPopTips("遇到Shein反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                                            //
                                             //
                                            need_item['_e_time'] = Date.now();
                                            let obj = {};
                                            obj[storage_key] = need_item;
                                            chrome.storage.local.set(obj, function (){
                                            });
                                            break;
                                            return;
                                            //
                                        }
                                    }
                                    //
                                }else{
                                    //
                                    if(specs_key2_name){ //有尺寸
                                        let _shangjia_variants_skus_cucao = shangjia_get_subskus(
                                            _dom,
                                            need_item['_shangjia_goodsId'],
                                            specs_key1_name,
                                            '',
                                            specs_key2_name,
                                            _shangjia_gallery,
                                            _main_image);
                                        for(let _c=0;_c<_shangjia_variants_skus_cucao.length;_c++){
                                            _shangjia_variants_skus.push(_shangjia_variants_skus_cucao[_c]);
                                        }
                                    }else{
                                        //无尺寸,无属性
                                        _shangjia_variants_skus.push({
                                            'subsku': need_item['_shangjia_goodsId']+'Z', //
                                            'normalPriceStr': _discount_price, //特价
                                            'normalLinePriceStr': _original_price, //原价
                                            'img':_main_image,
                                            'gallery_imgs':_shangjia_gallery,
                                            'video_url':_shangjia_VideoUrl,
                                            'specs_key1_name':'',
                                            'specs_key1_value':'',
                                            'specs_key2_name':'',
                                            'specs_key2_value':'',
                                            'specs_key3_name':'',
                                            'specs_key3_value':'',
                                            'specs_key4_name':'',
                                            'specs_key4_value':'',
                                            'stockQuantity': _goodsDetailV3SsrData_json['productIntroData']['detail']['stock'],
                                            'skuId': '' //原变体sku
                                        });
                                    }
                                    //
                                }
                                //
                                need_item['_shangjia_variants_skus'] = _shangjia_variants_skus;
                                need_item['_shangjia_gallery'] = _shangjia_gallery;
                                //
                                need_item['_shangjia_sold'] = 0;
                                let _shangjia_review_num = _dom.find('.product-intro__head-reviews-text').attr('data-review-num');
                                console.log('_shangjia_review_num');
                                console.log(_shangjia_review_num);
                                if(typeof _shangjia_review_num == 'undefined'){
                                    _shangjia_review_num = 0;
                                }else{
                                    _shangjia_review_num = parseInt(_shangjia_review_num);
                                }
                                need_item['_shangjia_reivew_num'] = _shangjia_review_num;
                                console.log('need_item');
                                console.log(need_item);
                                need_item['_is_request'] = 2;
                                //
                            }
                        }
                       //
                   }else{
                       //
                        console.log('scriptdata_json This item is sold out.反爬');
                        need_item['_is_request'] = 0;
                        need_item['_error'] = '';
                        pause_s_time();
                        sendPopTips("遇到Shein反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                        //
                   }
                   //
                   need_item['_e_time'] = Date.now();
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
                   /*if(need_item['_shangjia_img']){
                       urlToBase64(need_item['_shangjia_img'], function(base64String) {
                           //console.log(blob);
                            //need_item['_shangjia_img_blob'] = base64String;
                            //
                            need_item['_is_request'] = 2;
                            need_item['_e_time'] = Date.now();
                            let obj = {};
                            obj[storage_key] = need_item;
                            chrome.storage.local.set(obj, function (){
                            });
                            //
                        });
                   }*/
                   //
               }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('ajax error');
                console.log( jqXHR, textStatus, errorThrown );
                //
                need_item['_is_request'] = 0;
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                        //

                        //
                });
                //
                pause_s_time();
                sendPopTips("遇到Shein反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
            }
        });
        //
    })
}

function request_shangjia_about_contact_and_basic_info(){
    chrome.storage.local.get(null, function(items) {
        //
        let binfa = 0;
        for(let key in items){
             if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                 if(items[key]['_is_request'] == 1){
                     binfa++;
                     if(binfa == 5){
                         break;
                     }
                 }
             }
        }
        if(binfa < 5 || true){
          let need_item = null;
          for(let key in items){
                if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                    if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-10000))){
                        need_item = items[key];
                        need_item['_is_request'] = 1;
                        need_item['_s_time'] = Date.now();
                        let obj = {};
                        obj[key] = need_item;
                        chrome.storage.local.set(obj, function (){
                            //
                            request_shangjia_about_contact_and_basic_info_ajax(key);
                            //
                        });
                        break;
                    }
                }
          }
        }
        //
    });
}

function xintiao(){
     chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             //360000
             if(items.hasOwnProperty('pause_s_time')  && (items['pause_s_time']+60000) > Date.now()){
                console.log('爬取失败，暂停60s');
             }else{
                 console.log('爬取中');
                 request_shangjia_about_contact_and_basic_info();
             }
         }else{
             console.log('已暂停爬取');
         }
    });

    //request_shangjia_about_work_and_education_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao();
setInterval(xintiao, 40000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_about_work_and_education_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'shangjias'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;
    let has_caiji_company_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }

        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
            'has_caiji_company_num': has_caiji_company_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_shangjias_update(shangjia_infos=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('shangjias', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('shangjias')){
            let obj = {};
            let shangjias = [];
            for(let i=0;i<shangjia_infos.length;i++){
                shangjias.push(shangjia_infos[i]['_shangjia_id']);
            }
            obj['shangjias'] = shangjias;
            chrome.storage.local.set(obj);
        }else{
            let storage_shangjias = items['shangjias'];

            for(let i=0;i<shangjia_infos.length;i++){
                let is_exists = false;
                for(let j=0;j<storage_shangjias.length;j++){
                    if(shangjia_infos[i]['_shangjia_id'] == storage_shangjias[j]){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                    storage_shangjias.push(shangjia_infos[i]['_shangjia_id']);
                }
                //
            }
            //
            let obj = {};
            obj['shangjias'] = storage_shangjias;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        //storage_shangjias_update(shangjia_infos);
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],function (){

            });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 5000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'can_list_caiji'){
        console.log('can_list_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            //已开启
            let total_add_shangjia_num = 0;
            for(let key in items){
                if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                    total_add_shangjia_num += 1;
                }
            }
            if(total_add_shangjia_num < 3000){
                sendResponse(JSON.stringify({state:0}));
            }else{
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action == 'check_expire'){
        //
        chrome.storage.local.get(null, function(items) {
            //
            let prefix = 'expire';
            if (!items.hasOwnProperty(prefix)) {
               //
                sendResponse(JSON.stringify({state:1}));
                //
            }else{
                let expire_date = items['expire'];
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                if (util_check_expire(expire_date)) {
                    sendResponse(JSON.stringify({state:1}));
                }else{
                    sendResponse(JSON.stringify({state:0}));
                }
            }
        })
        return true;
        //
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = '', url=''){
    //
    if(url){
        console.log('sendPopTips url:'+url);
        chrome.tabs.create({url: url}, function(newTab) {
            // 监听标签页的更新事件
            chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
              // 检查页面是否已完全加载
              if (tabId === newTab.id && changeInfo.status === "complete") {
                // 在这里执行你想要在页面加载完成后执行的操作
                console.log("页面已完全加载");
                //sendResponse(JSON.stringify({}));
                // 你可以继续在这里添加其他代码
              }
            });
          });
    }
    //
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}